package com.magnatune.eyecreate.companionformagnatune.adapters;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.LocalBroadcastManager;
import android.view.View;
import android.view.ViewGroup;

import com.magnatune.eyecreate.companionformagnatune.BrowseActivity;
import com.magnatune.eyecreate.companionformagnatune.R;
import com.magnatune.eyecreate.companionformagnatune.fragments.ArtistFragment;
import com.magnatune.eyecreate.companionformagnatune.model.Artist;
import com.magnatune.eyecreate.companionformagnatune.viewholders.ArtistViewHolder;

import io.realm.RealmBasedRecyclerViewAdapter;
import io.realm.RealmResults;

public class ArtistsAdapter extends RealmBasedRecyclerViewAdapter<Artist,ArtistViewHolder> {

    public ArtistsAdapter(Context context, RealmResults<Artist> realmResults, boolean automaticUpdate, boolean animateResults, boolean addSectionHeaders, String headerColumnName) {
        super(context, realmResults, automaticUpdate, animateResults, addSectionHeaders, headerColumnName);
    }

    @Override
    public ArtistViewHolder onCreateRealmViewHolder(ViewGroup viewGroup, int i) {
        View v = inflater.inflate(R.layout.listitem_artist,viewGroup,false);
        ArtistViewHolder holder = new ArtistViewHolder(v);
        return holder;
    }

    @Override
    public void onBindRealmViewHolder(final ArtistViewHolder artistViewHolder, final int i) {
        artistViewHolder.artistName.setText(realmResults.get(i).getArtistname());
        artistViewHolder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Bundle args = new Bundle();
                args.putString(ArtistFragment.ARG_ARTIST_NAME,realmResults.get(i).getArtistname());
                Intent toArtist = new Intent(BrowseActivity.ACTION_ONCLICK_ACTIVATED);
                toArtist.putExtra(BrowseActivity.EXTRA_FRAGMENT, ArtistFragment.class.getName());
                toArtist.putExtra(BrowseActivity.EXTRA_FRAGMENT_ARGS,args);
                LocalBroadcastManager.getInstance(view.getContext()).sendBroadcast(toArtist);
            }
        });
    }
}
